package com.steerinfo.dil.controller;

import com.steerinfo.dil.feign.IMFeign;
import com.steerinfo.dil.model.Message;
import com.steerinfo.dil.model.OmstruckOrder;
import com.steerinfo.dil.model.OmstruckOrderMaterial;
import com.steerinfo.dil.service.IOmstruckOrderMaterialService;
import com.steerinfo.dil.service.IOmstruckOrderService;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/10/27 18:07
 */

@RestController
@RequestMapping("/${api.version}/utilscontroller")
public class UtilsController extends BaseRESTfulController {

    @Autowired
    IOmstruckOrderService omstruckOrderService;

    @Autowired
    IOmstruckOrderMaterialService omstruckOrderMaterialService;

    @Autowired
    IMFeign imFeign;

    @ApiOperation(value = "运输订单新增方法")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "map", value = "运输订单主键id加同意/拒绝状态码", required = false, dataType = "Map"),
    })
    @PostMapping("/insertSelectiveOrder")
    public RESTfulResult insertSelectiveOrder(@RequestBody(required = false) OmstruckOrder omstruckOrder) {
        int i = omstruckOrderService.insertSelective(omstruckOrder);
        return success(i);
    }


    @ApiOperation(value = "运输订单子表新增方法")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "map", value = "运输订单主键id加同意/拒绝状态码", required = false, dataType = "Map"),
    })
    @PostMapping("/insertSelectiveOrderMaterial")
    public RESTfulResult insertSelectiveOrderMaterial(@RequestBody(required = false) OmstruckOrderMaterial omstruckOrderMaterial) {
        int i = omstruckOrderMaterialService.insertSelective(omstruckOrderMaterial);
        return success(i);
    }

    //这里是websocket的测试方法
    @RequestMapping("/websocket/sendToUser")
    @ResponseBody
    public String sendToUser(@RequestBody List<Message> messages) {

        HashMap<String, Object> map = new HashMap<>();
        map.put("messages", messages);
        imFeign.sendToUser(map);
        return "成功！";
    }
}
